#
# Copyright (c) 1998 Regents of the University of California.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement:
#       This product includes software developed by the Computer Systems
#       Engineering Group at Lawrence Berkeley Laboratory.
# 4. Neither the name of the University nor of the Laboratory may be used
#    to endorse or promote products derived from this software without
#    specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# ------------
#
# Filename: mashcast.tcl
#   -- Created on Thu Aug 13 1998
#   -- Author: Yatin Chawathe <yatin@cs.berkeley.edu>
#
# Description:
#
#
#  @(#) $Header: /usr/src/mash/repository/mash/mash-1/tcl/applications/mashcast/mashcast.tcl,v 1.2 1998/10/23 18:01:28 yatin Exp $
#



import CastingDirector_v2 CastingDirectorUI RemoteController


Class MashCast


MashCast public init { path {munge_url_port {}} } {
	$self instvar ui_ director_ munge_url_port_ remote_controller_
	if { $path!="." } {
		set ui_ $path.mashcast_ui
	} else {
		set ui_ .mashcast_ui
	}
	CastingDirectorUI $ui_
	pack $ui_ -fill both -expand 1
	set director_ [new CastingDirector_v2]
	set remote_controller_ [new RemoteController $munge_url_port]
	$ui_ director $director_
	$director_ callback $remote_controller_

	set munge_url_port_ $munge_url_port
}


MashCast public destroy { } {
	$self instvar ui_ director_ remote_controller_
	delete $ui_
	delete $director_
	delete $remote_controller_
}


MashCast public ui { } {
	return [$self set ui_]
}


MashCast public remote_controller { port } {
	$self instvar remote_controller_ ui_
	puts "starting remote controller on $port"
	$remote_controller_ use_socket $port "$self remote_ctrl_started"

	$ui_ subwidget urllist subwidget entry delete 0 end
	$ui_ subwidget urllist subwidget entry insert 0 \
			"Waiting for Remote Controller"
	$ui_ enable 0
}


MashCast private remote_ctrl_started { } {
	$self instvar ui_
	$ui_ enable 1
	$ui_ subwidget urllist subwidget entry delete 0 end
	$ui_ subwidget urllist subwidget entry insert 0 ""
}
