#
# Check that the address specification <i>argv</i> is valid and present
# (if needed).  Returns its argument.
#
SRMv2_Manager private check_hostspec { argv } {
        $self instvar name_
        if { $argv == "" } {
                if { [$self get_option megaSession] == "" } {
                        $self fatal "destination address required"
                }
        } elseif { [llength $argv] > 1 } {
                set extra [lindex $argv 0]
                $self fatal "extra arguments (starting with $extra)"
        }
        return $argv
}

SRMv2_Manager instproc parse_epilog { argv } { 
        $self instvar name_

        if { $argv == "" } {
                if { [$self get_option defaultHostSpec] == "" && \
				[$self get_option megaSession] == "" } {
                        puts stderr "$name_: destination address required"
                        exit 1
                }
        } elseif { [llength $argv] > 1 } {
                set extra [lindex $argv 0]
                puts stderr "$name_: extra arguments (starting with $extra)"
                exit 1
        } else {
                $self add_option defaultHostSpec $argv
        }
}

SRMv2_Manager instproc create-session { } {
	$self instvar bpool_ lsrc_ session_
        set session_ [new Session/SRMv2]
	set bpool_ [new BufferPool/SRMv2]
	set lsrc_ [$session_ create-local-source "[exec whoami]@[info hostname]"]
	$bpool_ srmv2-source $lsrc_
	$session_ buffer-pool $bpool_
}

SRMv2_Manager instproc reset { ab } {
	$self instvar network_ session_
	
	if [info exists network_] {
		delete $network_
	}
	set network_ [new NetworkManager $ab $session_ $self]
	set key [[Application instance] get_option sessionKey]
	if { $key != "" } {
		$network_ install-key $key
	}
}

SRMv2_Manager instproc set_maxchannel { n } { } 

SRMv2_Manager instproc application {app} {
	$self instvar application_
	set application_ $app
}

#
# Hand over named data buffer to the application
# 
SRMv2_Manager instproc recv { nm seqno blk } {
	$self instvar application_
	$application_ handle $nm $seqno $blk
}

SRMv2_Manager instproc reada { nm seqno } {
	$self instvar application_
	return [$application_ reada $nm $seqno]
}


SRMv2_Manager instproc recover { nm start end } {
	$self instvar application_
	return [$application_ recover $nm $start $end]
}

SRMv2_Manager instproc get-adu { nm seqno } {
	$self instvar application_
	return [$application_ get-adu $nm $seqno]
}

SRMv2_Manager instproc enqueue { nm seqno ss es } {
	$self instvar application_
	return [$application_ enqueue $nm $seqno $ss $es]
}






